<template>
  <router-view />
</template>

<script>
import { useRouter } from 'vue-router';
import { defineComponent } from 'vue';
import { useAuthStore } from 'src/stores/authStore.js';
import * as jose from 'jose';

export default defineComponent({ // in start
  name: 'App',
  setup() {
    const router = useRouter();
    const authStore = useAuthStore();
    if (authStore.jwt) {
      authStore.fetchProfile();
    }

    // setTimeOut (check JWT validity)
    setInterval(() => {
      if (authStore.jwt) {
        // execution if connect
        const claims = jose.decodeJwt(authStore.jwt);
        const validityexpDS = new Date(claims.exp * 1000);
        const theDate = new Date();
        const restTime = Date.parse(validityexpDS) - Date.parse(theDate);
        if ((restTime) < 1000 * 60 * 10) { // refresh if restTime < 10 min
          const requestOptionsConn = {
            method: 'GET',
            headers: {
              Authorization: `Bearer ${authStore.jwt}`,
            },
          };
          fetch(
            `${import.meta.env.VITE_FETCH_BACK}/refresh`,
            requestOptionsConn,
          )
            .then((response) => {
              if (response.status !== 200) {
                throw response.status;
              } else {
                // route to login page
                router.push('/');
                authStore.logout();
              }
              return response.json();
            })
            .then((json) => {
              authStore.jwt = json.newJwt;
            });
        } else {
          console.log('tocken is OK');
        }
      }
    }, 1000 * 60 * 5); // repeat 5 min
  },
});
</script>
